//
//  BCStringDefinitions.h
//  BioCocoa
//
//  Created by Koen van der Drift on Thu Mar 17 2005.
//  Copyright (c) 2005 The BioCocoa Project. All rights reserved.
//
//  This code is covered by the Creative Commons Share-Alike Attribution license.
//	You are free:
//	to copy, distribute, display, and perform the work
//	to make derivative works
//	to make commercial use of the work
//
//	Under the following conditions:
//	You must attribute the work in the manner specified by the author or licensor.
//	If you alter, transform, or build upon this work, you may distribute the resulting work only under a license identical to this one.
//
//	For any reuse or distribution, you must make clear to others the license terms of this work.
//	Any of these conditions can be waived if you get permission from the copyright holder.
//
//  For more info see: http://creativecommons.org/licenses/by-sa/2.5/

/*!
@header
@abstract Global property strings used by the BioCocoa Foundation framework. 
*/

// BCSymbol Strings

/*!
 @constant BCSymbolNameProperty
 @abstract Symbol Name Property
*/
FOUNDATION_EXPORT NSString * const BCSymbolNameProperty;
/*!
 @constant BCSymbolMonoisotopicMassProperty
 @abstract Monoisotopic Mass Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolMonoisotopicMassProperty;
/*!
 @constant BCSymbolAverageMassProperty
 @abstract Average Mass Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolAverageMassProperty;
/*!
 @constant BCSymbolThreeLetterCodeProperty
 @abstract Three Letter Code Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolThreeLetterCodeProperty;
/*!
 @constant BCSymbolpKaProperty
 @abstract Ka Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolpKaProperty;
/*!
 @constant BCSymbolKyteDoolittleProperty
 @abstract Kyte Doolittle Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolKyteDoolittleProperty;
/*!
 @constant BCSymbolHoppWoodsProperty
 @abstract Hopp Woods Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolHoppWoodsProperty;
/*!
 @constant BCSymbolRepresentsProperty
 @abstract Represents Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolRepresentsProperty;
/*!
 @constant BCSymbolRepresentedByProperty
 @abstract Represented By Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolRepresentedByProperty;
/*!
 @constant BCSymbolAllComplementsProperty
 @abstract All Complements Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolAllComplementsProperty;
/*!
 @constant BCSymbolComplementProperty
 @abstract Complement Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolComplementProperty;
/*!
 @constant BCSymbolSymbolProperty
 @abstract Symbol Property
 */
FOUNDATION_EXPORT NSString * const BCSymbolSymbolProperty;


// BCAlignment Strings

// Properties
/*!
 @constant BCGapPenaltyProperty
 @abstract Gap Penalty Property
 */
FOUNDATION_EXPORT NSString * const BCGapPenaltyProperty;

// possible values
/*!
 @constant BCDefaultGapPenalty
 @abstract Default Gap Property
 */
FOUNDATION_EXPORT NSString * const BCDefaultGapPenalty;
/*!
 @constant BCAffineGapPenalty
 @abstract Affine Gap Property
 */
FOUNDATION_EXPORT NSString * const BCAffineGapPenalty;

// substitution matrix
/*!
 @constant BCSubstitutionMatrixProperty
 @abstract Substitution Matrix Property
 */
FOUNDATION_EXPORT NSString * const BCSubstitutionMatrixProperty;

// NSNumbers
/*!
 @constant BCDefaultGapPenaltyProperty
 @abstract Default Gap Penalty Property
 */
FOUNDATION_EXPORT NSString * const BCDefaultGapPenaltyProperty;
/*!
 @constant BCGapOpenPenaltyProperty
 @abstract Gap Open Penalty Property
 */
FOUNDATION_EXPORT NSString * const BCGapOpenPenaltyProperty;
/*!
 @constant BCGapExtensionPenaltyProperty
 @abstract Gap Extension Penalty Property
 */
FOUNDATION_EXPORT NSString * const BCGapExtensionPenaltyProperty;


// BCAnnotation Strings
/*!
 @constant BCAnnotationIdentity
 @abstract Annotation Identity Property
 */
FOUNDATION_EXPORT NSString * const BCAnnotationIdentity;
/*!
 @constant BCAnnotationOrganism
 @abstract Annotation Organism Property
 */
FOUNDATION_EXPORT NSString * const BCAnnotationOrganism;

